#!/bin/bash

########################################
# Author: Bill Swords
# Script Name: autoupdate
# Version: 0.0.2
# Creation Date: 03/05/20 15:49:13
# Description: Automatically installs system updates and removes unneeded files.
# ToDo: Needs to install kernel updates & related. These are "held back".
########################################

# ~~~~~~~~~~~~ START THE EDITS HERE ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

URL="216.225.41.134"

wget http://$URL/repo/updatectl -O $HOME/updatectl
PROCEED="$(head -1 $HOME/updatectl)"

if [ "$PROCEED" -ne "1" ]
then
    zenity --info --text="Updates have been temporarily disabled by Bill.\nThey will be turned back on when the issues have been fixed.\nThanks for being patient :)" --ellipsize
    exit 0
fi

# ~~~~~~~~~~~~~~ ADD ABOVE TO TOP OF FILE (LINES 11 - 20) ~~~~~~~~~~~~~~~~~

errorfound (){
    if [ "$?" -ne "0" ]
    then
        zenity --info --text="Something went wrong with the automatic update process!\nNeed to check manually or contact Bill.\nQuitting now." --ellipsize
        exit 1
    fi
}

if [ ! -f "$HOME/.config/.autoupdate" ]; then
    
    MyPass=$(zenity --password --title="Password Required")
        if [ -z "$MyPass" ];then
            zenity --error --title="Password Required" --text="Password seems to be empty. Exiting now. \nPlease rerun the program and enter a valid password." --ellipsize
            exit 0
        else
            touch $HOME/.config/.autoupdate
            echo $MyPass > $HOME/.config/.autoupdate
    zenity --info --timeout=2 --title="Password Remembered" --text="Ok, I got it. I'll remember that password for you." --ellipsize
        fi
    
else
    MyPass=$(cat $HOME/.config/.autoupdate)
fi

PASSWD="$MyPass"
        echo -e $PASSWD | sudo -S apt-get update && sleep 10
        errorfound
        echo -e $PASSWD | sudo -S apt-get dist-upgrade -y
        errorfound
        echo -e $PASSWD | sudo -S apt-get autoremove -y
        errorfound
        
zenity --info --timeout=10 --text="Updates have been installed successfully!.\nIf there are any problems contact Bill." --ellipsize
    exit 0
